// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/collections -i Collections -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/collections"
	"git.perx.ru/perxis/perxis-go/pkg/schema"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements collections.Collections that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   collections.Collections
}

// AccessLoggingMiddleware instruments an implementation of the collections.Collections with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next collections.Collections) collections.Collections {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Create(ctx context.Context, coll *collections.Collection) (created *collections.Collection, err error) {
	begin := time.Now()

	m.logger.Debug("Create.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("coll", coll),
	)

	created, err = m.next.Create(ctx, coll)

	m.logger.Debug("Create.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("created", created),
		zap.Error(err),
	)

	return created, err
}

func (m *accessLoggingMiddleware) Delete(ctx context.Context, spaceId string, envId string, id string) (err error) {
	begin := time.Now()

	m.logger.Debug("Delete.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("id", id),
	)

	err = m.next.Delete(ctx, spaceId, envId, id)

	m.logger.Debug("Delete.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Get(ctx context.Context, spaceId string, envId string, id string, options ...*collections.GetOptions) (coll *collections.Collection, err error) {
	begin := time.Now()

	m.logger.Debug("Get.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("id", id),
		zap.Reflect("options", options),
	)

	coll, err = m.next.Get(ctx, spaceId, envId, id, options...)

	m.logger.Debug("Get.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("coll", coll),
		zap.Error(err),
	)

	return coll, err
}

func (m *accessLoggingMiddleware) List(ctx context.Context, spaceId string, envId string, filter *collections.Filter) (colls []*collections.Collection, err error) {
	begin := time.Now()

	m.logger.Debug("List.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("filter", filter),
	)

	colls, err = m.next.List(ctx, spaceId, envId, filter)

	m.logger.Debug("List.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("colls", colls),
		zap.Error(err),
	)

	return colls, err
}

func (m *accessLoggingMiddleware) SetSchema(ctx context.Context, spaceId string, envId string, id string, schema *schema.Schema) (err error) {
	begin := time.Now()

	m.logger.Debug("SetSchema.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("id", id),
		zap.Reflect("schema", schema),
	)

	err = m.next.SetSchema(ctx, spaceId, envId, id, schema)

	m.logger.Debug("SetSchema.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) SetState(ctx context.Context, spaceId string, envId string, id string, state *collections.StateInfo) (err error) {
	begin := time.Now()

	m.logger.Debug("SetState.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("id", id),
		zap.Reflect("state", state),
	)

	err = m.next.SetState(ctx, spaceId, envId, id, state)

	m.logger.Debug("SetState.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Update(ctx context.Context, coll *collections.Collection) (err error) {
	begin := time.Now()

	m.logger.Debug("Update.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("coll", coll),
	)

	err = m.next.Update(ctx, coll)

	m.logger.Debug("Update.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}
