// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/recovery
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/environments -i Environments -t ../../../assets/templates/middleware/recovery -o recovering_middleware.go -l ""

import (
	"context"
	"fmt"

	"git.perx.ru/perxis/perxis-go/pkg/environments"
	"go.uber.org/zap"
)

// recoveringMiddleware implements environments.Environments that is instrumented with logging
type recoveringMiddleware struct {
	logger *zap.Logger
	next   environments.Environments
}

// RecoveringMiddleware instruments an implementation of the environments.Environments with simple logging
func RecoveringMiddleware(logger *zap.Logger) Middleware {
	return func(next environments.Environments) environments.Environments {
		return &recoveringMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *recoveringMiddleware) Create(ctx context.Context, env *environments.Environment) (created *environments.Environment, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Create(ctx, env)
}

func (m *recoveringMiddleware) Delete(ctx context.Context, spaceId string, id string) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Delete(ctx, spaceId, id)
}

func (m *recoveringMiddleware) Get(ctx context.Context, spaceId string, id string) (env *environments.Environment, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Get(ctx, spaceId, id)
}

func (m *recoveringMiddleware) List(ctx context.Context, spaceId string) (envs []*environments.Environment, err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.List(ctx, spaceId)
}

func (m *recoveringMiddleware) Migrate(ctx context.Context, spaceId string, id string, options ...*environments.MigrateOptions) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Migrate(ctx, spaceId, id, options...)
}

func (m *recoveringMiddleware) RemoveAlias(ctx context.Context, spaceId string, id string, alias string) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.RemoveAlias(ctx, spaceId, id, alias)
}

func (m *recoveringMiddleware) SetAlias(ctx context.Context, spaceId string, id string, alias string) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.SetAlias(ctx, spaceId, id, alias)
}

func (m *recoveringMiddleware) Update(ctx context.Context, env *environments.Environment) (err error) {
	logger := m.logger
	defer func() {
		if r := recover(); r != nil {
			logger.Error("panic", zap.Error(fmt.Errorf("%v", r)))
			err = fmt.Errorf("%v", r)
		}
	}()

	return m.next.Update(ctx, env)
}
